// ============================================================
// ==== Programm zur Messung der magnetischen Flussdichte B ===
// ============================================================

#include <LiquidCrystal_I2C.h>
#include <Wire.h>

LiquidCrystal_I2C lcd(0x27,16,2);  // ACHTUNG: set the LCD address to 0x20 or 0x27 for a 16 chars and 2 line display!!!

// Anschlüsse:
// GND - GND
// VCC - 5V
// SDA - ANALOG Pin 4
// SCL - ANALOG Pin 5
// Hallsensor - ANAALOG Pin 1


float sensorValue = 0;  // variable to store the value coming from the sensor connected to A1
float B;                // variable for the magnetic flux density B


void setup()
   {
    Serial.begin(9600);
    
    lcd.init();                      // initialize the lcd

    // Print a message to the LCD.
    lcd.backlight();
    lcd.setCursor(0,0);
    lcd.print("Flussdichte");
    lcd.setCursor(0,1);
    lcd.print("B = ");
   }


void loop()
   {
    sensorValue = analogRead(A1);               // read the value from the sensor

    sensorValue = (sensorValue/1023.0) * 5.0;   // Eingangsspannung in Volt

    B = 0.04 * sensorValue - 0.1;               // Flussdichte in Tesla
   
    /*
    Serial.print("B = " );                       
    Serial.println(B, 4);      
    */
    
    // Ausgabe auf dem LCD-Schirm
    // ==========================

    lcd.setCursor(4,1);
    lcd.print("          ");
    lcd.setCursor(4,1);
    lcd.print(B,3);
    lcd.setCursor(11,1);
    lcd.print("T");
    
    delay(200);
   }





